# == Class: postfix
#
# === Examples
#
#  class { 'postfix':
#    myhostname      => 'mail.example.com',
#    mydomain        => 'example.com',
#    mynetworks      => '192.168.1.0/24, 127.0.0.0/8',
#  }
#
# === Authors
#
# Aneesh C <aneeshchandrasekharan@gmail.com>
#

class postfix (
  $package_name                        = $::postfix::params::package_name,
  $template                            = $::postfix::params::template,
  $myhostname                          = undef,
  $mydomain                            = undef,
  $myorigin                            = undef,
  $inet_interfaces                     = 'all',
  $inet_protocols                      = undef,
  $mydestination                       = undef,
  $mynetworks                          = undef,
  $home_mailbox                        = undef,
  $message_size_limit                  = undef,
  $virtual_alias_domains               = undef,
  $virtual_alias_maps                  = undef,
  $virtual_mailbox_domains             = undef,
  $virtual_mailbox_maps                = undef,
  $virtual_mailbox_base                = undef,
  $virtual_uid_maps                    = undef,
  $virtual_gid_maps                    = undef,
  $smtpd_sasl_type                     = undef,
  $smtpd_sasl_path                     = undef,
  $smtpd_sasl_auth_enable              = undef,
  $broken_sasl_auth_clients            = undef,
  $smtpd_sasl_authenticated_header     = undef,
  $smtpd_recipient_restrictions        = undef,
  $smtpd_use_tls                       = undef,
  $smtpd_tls_cert_file                 = undef,
  $smtpd_tls_key_file                  = undef,
  $virtual_create_maildirsize          = undef,
  $virtual_maildir_extended            = undef,
  $proxy_read_maps                     = undef,
  $virtual_transport                   = undef,
  $dovecot_destination_recipient_limit = undef,
) inherits postfix::params {
  package { $package_name: ensure => installed }
  file { '/etc/postfix/main.cf':
    require => package[$package_name],
    content => template($template),
  }
  if $::osfamily == 'RedHat' {
    service { 'postfix':
      require => package[$package_name],
      enable  => true,
    }
  }
}
